VolumeDataReader
Date: 2019-10-22

org.jmol.jvxl.readers

## Class VolumeDataReader

- java.lang.Object
- - org.jmol.jvxl.readers.SurfaceReader
  - - org.jmol.jvxl.readers.VolumeDataReader

- All Implemented Interfaces:
    VertexDataServer
  Direct Known Subclasses:
    AtomDataReader, IsoShapeReader

      class VolumeDataReader
      extends SurfaceReader

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `allowMapData`
    `protected int` | `dataType`
    `protected int` | `maxGrid`
    `protected javajs.util.P3` | `point`
    `protected boolean` | `precalculateVoxelData`
    `protected float` | `ptsPerAngstrom`
    `protected boolean` | `useOriginStepsPoints`

    - ### Fields inherited from class org.jmol.jvxl.readers.SurfaceReader

      `allowSigma, ANGSTROMS_PER_BOHR, anisotropy, center, cJvxlEdgeNaN, colorFractionBase, colorFractionRange, contourVertexCount, dataMax, dataMean, dataMin, defaultCutoff, defaultMappedDataMax, defaultMappedDataMin, eccentricityMatrix, eccentricityMatrixInverse, eccentricityRatio, eccentricityScale, edgeFractionBase, edgeFractionRange, fractionData, hasColorData, haveSurfaceAtoms, isAnisotropic, isEccentric, isJvxl, isPeriodic, isProgressive, isQuiet, isXLowToHigh, jvxlColorDataRead, jvxlCutoff, jvxlData, jvxlDataIs2dContour, jvxlDataIsColorDensity, jvxlDataIsColorMapped, jvxlDataIsPrecisionColor, jvxlEdgeDataRead, jvxlFileHeaderBuffer, jvxlNSurfaceInts, jvxlVoxelBitSet, marchingCubes, marchingSquares, meshData, meshDataServer, minMax, nBytes, nDataPoints, nPointsX, nPointsY, nPointsZ, params, ptTemp, qpc, sg, vertexDataOnly, volumeData, volumetricOrigin, volumetricVectors, voxelCounts, voxelData, xyzMax, xyzMin, yzCount, yzPlanes`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `VolumeDataReader()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `closeReader()`
    `protected void` | `generateCube()`
    `(package private) void` | `init(SurfaceGenerator sg)` implemented in SurfaceFileReader and
    `protected void` | `initVDR(SurfaceGenerator sg)`
    `protected void` | `readSurfaceData(boolean isMapData)`
    `protected void` | `readSurfaceDataVDR(boolean isMapData)`
    `protected boolean` | `readVolumeData(boolean isMapData)`
    `protected boolean` | `readVolumeParameters(boolean isMapData)`
    `protected void` | `readVoxelDataIndividually(boolean isMapData)`
    `(package private) void` | `setup(boolean isMapData)`
    `protected void` | `setVolumeData()`
    `protected boolean` | `setVolumeDataParams()`
    `protected int` | `setVoxelRange(int index, float min, float max, float ptsPerAngstrom, int gridMax, float minPointsPerAngstrom)`
    `protected void` | `showGridInfo()`

    - ### Methods inherited from class org.jmol.jvxl.readers.SurfaceReader

      `addTriangleCheck, addVC, addVertexCopy, applyColorScale, colorIsosurface, createIsosurface, discardTempData, discardTempDataSR, excludeMaximumSet, excludeMinimumSet, finalizeMapping, getColorPhaseIndex, getMinMaxMappedValues, getPlane, getPlaneSR, getSPF, getSurfaceAtomIndex, getSurfacePointAndFraction, getSurfacePointIndexAndFraction, getValue, getValue2, getValueAtPoint, gotoAndReadVoxelData, gotoData, initializeMapping, initializeVolumetricData, initPlanes, initSR, jvxlUpdateInfo, newVoxelDataCube, postProcessVertices, readAndSetVolumeParameters, readColorData, resetIsosurface, selectPocket, setBBox, setOutputChannel, setVectorAnisotropy, setVertexAnisotropy, setVolumeDataV, setVolumetricAnisotropy, setVolumetricOriginAnisotropy, slabIsosurface, updateSurfaceData, updateTriangles`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### dataType

          protected int dataType

    - #### precalculateVoxelData

          protected boolean precalculateVoxelData

    - #### allowMapData

          protected boolean allowMapData

    - #### point

          protected javajs.util.P3 point

    - #### ptsPerAngstrom

          protected float ptsPerAngstrom

    - #### maxGrid

          protected int maxGrid

    - #### useOriginStepsPoints

          protected boolean useOriginStepsPoints

  - ### Constructor Detail

    - #### VolumeDataReader

          VolumeDataReader()

  - ### Method Detail

    - #### init

          void init(SurfaceGenerator sg)

      Description copied from class: `SurfaceReader`
      implemented in SurfaceFileReader and
      Specified by:
        `init` in class `SurfaceReader`

    - #### initVDR

          protected void initVDR(SurfaceGenerator sg)

    - #### setup

          void setup(boolean isMapData)

      Parameters:
        `isMapData` -

    - #### readVolumeParameters

          protected boolean readVolumeParameters(boolean isMapData)

      Specified by:
        `readVolumeParameters` in class `SurfaceReader`

    - #### readVolumeData

          protected boolean readVolumeData(boolean isMapData)

      Specified by:
        `readVolumeData` in class `SurfaceReader`

    - #### readVoxelDataIndividually

          protected void readVoxelDataIndividually(boolean isMapData)
                                            throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### setVolumeData

          protected void setVolumeData()

    - #### setVolumeDataParams

          protected boolean setVolumeDataParams()

    - #### showGridInfo

          protected void showGridInfo()

    - #### setVoxelRange

          protected int setVoxelRange(int index,
                                      float min,
                                      float max,
                                      float ptsPerAngstrom,
                                      int gridMax,
                                      float minPointsPerAngstrom)

      Parameters:
        `index` -
        `min` -
        `max` -
        `ptsPerAngstrom` -
        `gridMax` -
        `minPointsPerAngstrom` - -- added, but not necessary
      Returns:
        number of grid points total

    - #### readSurfaceData

          protected void readSurfaceData(boolean isMapData)
                                  throws java.lang.Exception

      Specified by:
        `readSurfaceData` in class `SurfaceReader`
      Throws:
        `java.lang.Exception`

    - #### readSurfaceDataVDR

          protected void readSurfaceDataVDR(boolean isMapData)
                                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### generateCube

          protected void generateCube()

    - #### closeReader

          protected void closeReader()

      Specified by:
        `closeReader` in class `SurfaceReader`